	//|=============================================|
	//|				MakeG3d "mkG3d.exe"				|
	//|			 (C) Matthew Leonard 2003	    	|
	//|												|
	//|					  [mkG3d.cpp]				|
	//|=============================================|

/*
If you modify this source code and distribute the binary the source code also must be included as well as all original copyright notices.

CONTACT INFO

To mail me please use lenny@bwgarage.co.uk
I can also be found on these message boards: http://boards.bwgame.com as lenny_la9
*/

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>

int main(void)
{
	fstream fileOut, fileIn, fileMesh;
	char lionHeader [8] = {'L', 'i', 'O', 'n', 'H', 'e', 'A', 'd'};
	char strNumTex [4]; 
	long numTex=0;
	char *fileData;
	char spaceFiller [3044] = {0}; //lots fo white space in the G3D file

	cout << "Welcome to Make G3D\n\n";
	cout << "[Linking High res textures]\n";
	//Straight after the file header the next 4 bytes contain the texture number. ..
	//therefore we retrieve the number of hi-res texxtures.
	
	fileIn.open("textures.txt", ios::in);
	
	if (fileIn.is_open())
	{
		fileIn.getline(strNumTex , 4);
		numTex = atol(strNumTex);
		cout << "there are: " << numTex << " textures\n";

	}
	else
	{
		cout << "Could not open file: 'textures.txt'\n..closing\n";
		return 0; //Without the information the program will crash later on, so we'll close it now instead.
	}
	fileIn.close ();

	//Now we open the output file
	fileOut.open ("AllMeshes.g3d", ios::out | ios::binary);
	
	if (fileOut.is_open())
	{
		
		long *textureInfo;
		textureInfo = new long [numTex];
		char textureType[4];

		cout << "file opened successfully\n";
		//Now write the header
		fileOut.write ((char*) &lionHeader, 8);
		//Enter a texture loop
		for (int texLoop = numTex; texLoop > 0; texLoop--)
		{
			//Write the texture number
			
			// output the texture number
			char chrTex[4] = {0};

			ltoa(texLoop, chrTex, 16);
			fileOut.write ((char*) &chrTex[0], 4);
			
			//28 useless bytes go here, dont know why.
			fileOut.write ((char*) &spaceFiller, 28);
			
			//all other workings now need to be done after the input texture is opened
			//Maybe the otehrs too - lcean up!

			//Now read in the sequence of dds textures
			char texName [100] = "textures\\";
			itoa(texLoop, strNumTex, 10);
			strcat(texName, strNumTex);
			strcat(texName, ".dds");

			fileIn.open(texName, ios::in | ios::binary);

			if (fileIn.is_open())
			{

				//Find the length of the input file
				fileIn.seekg(0, ios::end);
				long fileEof = fileIn.tellg();
				fileEof +=12;
				//Setup and output texture length including the header section of 12 bytes
				fileOut.write ((char*) &fileEof, 4);
				fileOut.write ((char*) &fileEof, 4);
				
				fileOut.write ((char*) &texLoop, 4);
				
				//Get and print texture type to file, also store type to an array for writing
				//in the info section

				fileIn.seekg(84, ios::beg);
				fileIn.read((char*) &textureType[0], 4);

				// Need to find out if the texture file is saved as DXT1 (type 1) or DXT3 (type 2)
				if (textureType[0] == 'D' && textureType[1] == 'X' && textureType[2] == 'T' && textureType[3] == '3')
				{
					textureInfo[texLoop] = 2;
				}
				else
				{
					textureInfo[texLoop] = 1;
				}
				
				//long texType;
				fileOut.write ((char*) &textureInfo[texLoop], 4);

				fileEof -=12;
				fileOut.write ((char*) &fileEof, 4);
				
				fileEof -=4;

				// need to check to see whether the dds file is 0 bytes

				fileData = new char [fileEof+1];
				fileIn.seekg (4, ios::beg);
				fileIn.read ((char*) &fileData[0], fileEof);
				
				fileOut.write (fileData, fileEof);

			}
			else
			{
				cout << "Could not open texture ID: " << texLoop << "\n\nclosing...";
				return 0;
			}
			fileIn.close();

		}
		
		cout << "High res texture linking completed\n";
		//high res texture linking is complete
		
		//Now compile the info section of the file
		
		//First comes the info header section
		char infoHeader[4] = {'I', 'N', 'F', 'O'};
		fileOut.write((char*) &infoHeader, 4);
		
		//Just fill this with white space
		fileOut.write((char*) &spaceFiller, 28);
		
		//I dont know what this section of bytes does.
		long unknownSection = 4100;
		fileOut.write((char*) &unknownSection, 4);
		
		//before the actual texture info we write the number of textures
		fileOut.write((char*) &numTex, 4);

		for (texLoop = numTex; texLoop > 0; texLoop --)
		{

			fileOut.write((char*) &texLoop, 4);
			fileOut.write((char*) &textureInfo[texLoop], 4);


		}
		
		//More white space
		
		fileOut.write((char*) &spaceFiller, 148);
		
		//quite a big heafer section here. Dont know what any of it does exactly though.
		unsigned char unknownHeader[24] = {132, 115, 98, 81, 00, 00, 00, 00, 39, 03, 131, 0, 1, 16, 0, 0, 120, 1, 194, 00, 120, 1, 194, 00};

		fileOut.write((char*) &unknownHeader, 24);

		//now some more unknown bytes.
		fileOut.write((char*) &spaceFiller, 3044);

		/////////////////////////////////////////////////
		// Mesh header section then the mesh data
		/////////////////////////////////////////////////

		char meshHeader[6] = {'M', 'E', 'S', 'H', 'E', 'S'};
		fileOut.write((char*) &meshHeader, 6);

		// yet more bytes of nothing in particular
		fileOut.write((char*) &spaceFiller, 26);
		
		unsigned char unknownMeshHeader[4] = {26, 53, 106, 0};
		fileOut.write((char*) &unknownMeshHeader, 4);

		char smallMeshHeader [4] = {'M', 'K', 'J', 'C'};
		fileOut.write((char*) &smallMeshHeader, 4);

		char strNumMesh[255];
//		char strOffset[255];
		long numberOfMeshes;
		long *meshOffsets;
		char meshName [255];
		long sumOffset = 0;

		//Now we work out the offsest, first open the mesh list
		fileIn.open("standardmesh.txt", ios::in);
	
		if (fileIn.is_open())
		{
			fileIn.getline(strNumMesh , 5);
			numberOfMeshes = atol(strNumMesh);

			meshOffsets = new long[numberOfMeshes];
			//meshName = new char[numberOfMeshes];
			fileOut.write ((char*) &numberOfMeshes, 4);
			
			// The first mesh offset is the size of the offset data block.
			meshOffsets[numberOfMeshes] = ((numberOfMeshes*sizeof(long))+8);
			fileOut.write ((char*) &meshOffsets[numberOfMeshes], 4);
			sumOffset = meshOffsets[numberOfMeshes];

			for (long meshNum = (numberOfMeshes-1); meshNum > 0; meshNum--)
			{

				fileIn.getline(meshName , 100);
				
				char l3dFile[256] = "meshes\\";
				strcat(l3dFile, meshName);
				strcat(l3dFile, ".l3d");
				

				fileMesh.open(l3dFile, ios::in);
				
				if (fileMesh.is_open())
				{
					fileMesh.seekg(0, ios::end);
					meshOffsets[meshNum] = (fileMesh.tellg() + meshOffsets[meshNum+1]);
					//sumOffset += meshOffsets[meshNum];

					fileOut.write ((char*) &meshOffsets[meshNum], 4);

				}
				else
				{
					cout << "Cannot open mesh file:" << l3dFile << ".l3d\n";
					return 0;
				}
				fileMesh.close();

			}

			
		}
		else
		{
			cout << "Could not open file: 'textures.txt'\n..closing\n";
			return 0; //Without the information the program will crash later on, so we'll close it now instead.
		}
		fileIn.close ();


		//Straight after the offsets are printed, we print the actual mesh info.
		char *fileData;

		fileIn.open("standardmesh.txt", ios::in);
	
		if (fileIn.is_open())
		{
			fileIn.getline(strNumMesh , 5);
			
			for (long meshNum = numberOfMeshes; meshNum > 0; meshNum--)
			{

				fileIn.getline(meshName , 100);
				
				char l3dFile[256] = "meshes\\";
				strcat(l3dFile, meshName);
				strcat(l3dFile, ".l3d");
				

				fileMesh.open(l3dFile, ios::in | ios::binary);
				
				if (fileMesh.is_open())
				{
					fileMesh.seekg(0, ios::end);
					long l3dLen = fileMesh.tellg();
					fileData = new char [l3dLen];

					fileMesh.seekg(0, ios::beg);
					fileMesh.read ((char*) &fileData[0], l3dLen);

					fileOut.write ((char*) &fileData[0], l3dLen);

				}
				else
				{
					cout << "Cannot open mesh file:" << l3dFile << ".l3d\n";
					return 0;
				}
				fileMesh.close();

			}
		}
		else
		{
			cout << "Could not open standardmesh.txt...\nquitting program.\n";
			return 0;
		}
		fileIn.close();
		
	
		for (texLoop = numTex; texLoop > 0; texLoop--)
		{

			//last of all, we need to output the low res textures
			char lowTexHeader [3] = {'L', 'O', 'W'};
			fileOut.write ((char*) &lowTexHeader[0], 3);

			//write the number of textures
			char chrTex[4] = {0};
			ltoa(texLoop, chrTex, 16);

			fileOut.write ((char*) &chrTex, 4);
			
			//white space
			fileOut.write ((char*) &spaceFiller[0], 25);

			//Now read in the sequence of dds textures
			char texName [100] = "textures\\";
			itoa(texLoop, strNumTex, 10);
			strcat(texName, strNumTex);
			strcat(texName, "-low.dds");
			
			
			fileIn.open(texName, ios::in | ios::binary);

			if (fileIn.is_open())
			{

				//Find the length of the input file
				fileIn.seekg(0, ios::end);
				long fileEof = fileIn.tellg();
				fileEof +=12;
				//Setup and output texture length including the header section of 12 bytes
				fileOut.write ((char*) &fileEof, 4);
				
				//find size for texture data and make a char array to hold it.
				fileIn.seekg(0, ios::beg);
				fileData = new char [fileEof+1];
				fileIn.seekg (4, ios::beg);
				fileIn.read ((char*) &fileData[0], fileEof);
				
				//more white space
				fileOut.write ((char*) &spaceFiller[0], 12);
				
				fileEof -=12;
				fileOut.write ((char*) &fileEof, 4);

				fileOut.write (fileData, (fileEof-4));

			}
			else
			{
				cout << "Could not open texture ID: " << texLoop << "\n\nclosing...";
				return 0;
			}
			fileIn.close();
		}

	}
	fileOut.close();

	return 0;
}

int getMeshEntry(int result)
{


	return 1;
}